Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/releases/release-110.63/install.sh
ViewVC logotype

Diff of /config/releases/release-110.63/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 489, Tue Nov 23 12:55:00 1999 UTC revision 573, Thu Mar 9 15:23:52 2000 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9  #set -x  # by M.Blume (2/2000).
10    #
11    
12  #  #
13  # get the target list  # get the target list
14  #  #
15  if [ ! -r config/targets ]; then  if [ ! -r config/targets ]; then
16    echo "!!! File config/targets is missing."    echo "!!! File config/targets is missing."
17    exit 1;      exit 1
18  fi  fi
19  . config/targets  . config/targets
20    
21  #  #
22  # some OSs have make in strange places  # create the preloads.standard file
23  #  #
24  MAKE=make  if [ ! -r config/preloads ]; then
25        echo "!!! File config/preloads is missing."
26        exit 1
27    fi
28    cp config/preloads preloads.standard
29    
30  #  #
31  # check for ksh  # Some OSs have make in strange places, but most of the time it is
32  #  # simply on the PATH:
 # ksh causes some people problems so we will always use /bin/sh  
33  #  #
34  #echo "checking for ksh"  MAKE=make
35  #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
36    SHELL=/bin/sh    SHELL=/bin/sh
 #fi  
37  echo Using shell $SHELL.  echo Using shell $SHELL.
38    
39  #  #
# Line 58  Line 57 
57  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
58  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
59    
60    URLGETTER=unknown
61    
62    #
63    # the path to the dir where ml-yacc, ml-burg, ml-lex, and ml-build live
64    #
65    TOOLDIR=$BINDIR
66    
67  #  #
68  # the paths to ml-yacc, ml-burg, and ml-lex; needed to configure CM  # files to be deleted after we are done...
69  #  #
70  YACCPATH=$BINDIR/ml-yacc  tmpfiles=""
71  LEXPATH=$BINDIR/ml-lex  tmpfiles="$tmpfiles $ROOT/preloads.standard"
72  BURGPATH=$BINDIR/ml-burg  tmpfiles="$tmpfiles $LIBLIST"
73    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
74    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
75    #
76    # make sure we always clean up after ourselves...
77    #
78    trap 'rm -f $tmpfiles' 0 1 2 3 15
79    
80    
81  #  #
82  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
83  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
84  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG_DEFAULT.
85  #  #
 CM_YACC_DEFAULT=$YACCPATH  
 CM_LEX_DEFAULT=$LEXPATH  
 CM_BURG_DEFAULT=$BURGPATH  
86  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig
87  export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATHCONFIG_DEFAULT  export CM_PATHCONFIG_DEFAULT
88    
89  #  #
90  # the release version that we are installing  # the release version that we are installing
# Line 83  Line 93 
93  echo Installing version $VERSION.  echo Installing version $VERSION.
94    
95  #  #
96    # the URL for the (usually remote) source archive
97    #
98    SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
99    echo URL of source archive is $SRCARCHIVEURL.
100    
101    #
102  # Function to make a directory (and advertise such action).  # Function to make a directory (and advertise such action).
103  #  #
104  makedir() {  makedir() {
# Line 98  Line 114 
114  }  }
115    
116  #  #
117    # Function for asking user to fetch source archive.
118    #   $1 - descriptive name
119    #   $2 - base name without extension, without version, and without dir
120    #   $3 - remote directory
121    #
122    askurl() {
123        echo Please, fetch $1 archive '('$VERSION-$2.'*)' from
124        echo '  ' $3
125        echo "and then re-run this script!"
126        exit 1
127    }
128    
129    #
130    # Function for fetching source archives automatically using wget or lynx.
131    #   $1 - command to actually get the stuff
132    #   $2 - descriptive name
133    #   $3 - base name without extension, without version, and without dir
134    #   $4 - remote directory
135    #
136    fetchurl() {
137        getter=$1 ; shift
138        echo Fetching $1 from $2. Please stand by...
139        fetched=no
140        for ext in tgz tar.gz tar.Z tz tar tar.bz2 ; do
141            try=$VERSION-$2.$ext
142            echo Trying $try ...
143            if $getter $3 $try $ROOT/$try ; then
144                fetched=yes
145                echo Success.
146                break
147            else
148                rm -f $ROOT/$try
149            fi
150        done
151        if [ $fetched = no ] ; then
152            echo No success.  You should try to do it manually now.
153            askurl "$1" "$2" "$3"
154        fi
155    }
156    
157    usewget() {
158        wget -nv -O $3 $1/$2
159    }
160    
161    uselynx() {
162        lynx -source $1/$2 >$3
163    }
164    
165    testurlgetter() {
166        (exec >/dev/null 2>&1 ; exec $*)
167    }
168    
169    #
170    # Function to check whether wget or lynx is available.
171    # Set URLGETTER accordingly.
172    #
173    urlgetter() {
174        if [ "$URLGETTER" = unknown ] ; then
175            if testurlgetter wget --help ; then
176                URLGETTER="fetchurl usewget"
177            elif testurlgetter lynx -help ; then
178                URLGETTER="fetchurl uselynx"
179            else
180                URLGETTER="askurl"
181            fi
182        fi
183    }
184    
185    #
186  # Function to unpack a source archive.  # Function to unpack a source archive.
187  #  #
188  # $1: descriptive name of the sources to be unpacked  # $1: descriptive name of the sources to be unpacked
# Line 106  Line 191 
191  # $4: the basename of the source archive (the script will check several  # $4: the basename of the source archive (the script will check several
192  #     different suffixes to determine what kind of de-compression is to  #     different suffixes to determine what kind of de-compression is to
193  #     be used)  #     be used)
194  unpack() {  #
195      if [ ! -d $2/$3 ]; then  # fetch_n_unpack is the helper function that does the real work.  If
196          echo Unpacking $1 source files.  # on archive is found locally, it invokes $URLGETTER and tries again.
197    # The variable $tryfetch is used to make sure this happens only once.
198    fetch_n_unpack() {
199        larc=$ROOT/$VERSION-$4
200          cd $2          cd $2
201          if [ -r $4.tar.Z ] ; then      if [ -r $larc.tar.Z ] ; then
202              zcat $4.tar.Z | tar -xf -          echo "Un-compress-ing and un-tar-ing $1 archive."
203          elif [ -r $4.tar ] ; then          zcat $larc.tar.Z | tar -xf -
204              tar -xf $4.tar      elif [ -r $larc.tar ] ; then
205          elif [ -r $4.tar.gz ] ; then          echo "Un-tar-ing $1 archive."
206              gunzip -c $4.tar.gz | tar -xf -          tar -xf $larc.tar
207          elif [ -r $4.tar.bz2 ] ; then      elif [ -r $larc.tar.gz ] ; then
208              bunzip2 -c $4.tar.bz2 | tar -xf -          echo "Un-gzip-ing and un-tar-ing $1 archive."
209          elif [ -r $4.tgz ] ; then          gunzip -c $larc.tar.gz | tar -xf -
210              gunzip -c $4.tgz | tar -xf -      elif [ -r $larc.tar.bz2 ] ; then
211          elif [ -r $4.tz ] ; then          echo "Un-bzip2-ing and un-tar-ing $1 archive."
212              zcat $4.tz | tar -xf -          bunzip2 -c $larc.tar.bz2 | tar -xf -
213        elif [ -r $larc.tgz ] ; then
214            echo "Un-gzip-ing and un-tar-ing $1 archive."
215            gunzip -c $larc.tgz | tar -xf -
216        elif [ -r $larc.tz ] ; then
217            echo "Un-compress-ing and un-tar-ing $1 archive."
218            zcat $larc.tz | tar -xf -
219        elif [ $tryfetch = yes ] ; then
220            urlgetter
221            $URLGETTER "$1" $4 $SRCARCHIVEURL
222            tryfetch=no
223            fetch_n_unpack "$1" "$2" "$3" "$4"
224        fi
225    }
226    
227    #
228    # The main "unpack" driver function that invokes the above helper.
229    #
230    unpack() {
231        tryfetch=yes
232        if [ -d $2/$3 ]; then
233            echo "The $1 tree already exists."
234          else          else
235              echo "!!! The $1 source files are missing."          fetch_n_unpack "$1" "$2" "$3" "$4"
             exit 1  
236          fi          fi
237          if [ ! -d $2/$3 ]; then          if [ ! -d $2/$3 ]; then
238              echo "!!! Unable to unpack $1 source files."          echo "!!! Unable to unpack $1 archive."
239              exit 1              exit 1
240          fi          fi
241    }
242    
243    # A function to move all stable library files to a parallel directory
244    # hierarchy.
245    # The first argument must be a simple path (no / inside), and
246    # the second argument must be an absolute path.
247    move() {
248        if [ -d $1 ] ; then
249            if [ ! -d $2 ] ; then
250                if [ -f $2 ] ; then
251                    echo install.sh: $2 exists as a non-directory.
252                    exit 1
253                fi
254                mkdir $2
255            fi
256            cd $1
257            for i in * ; do
258                move $i $2/$i
259            done
260            cd ..
261        elif [ -f $1 ] ; then
262            rm -f $2
263            mv $1 $2
264      fi      fi
265  }  }
266    
# Line 147  Line 278 
278  movelibs() {  movelibs() {
279      for lib in `/bin/ls $1/CM/$ARCH-unix` ; do      for lib in `/bin/ls $1/CM/$ARCH-unix` ; do
280          case $lib in          case $lib in
281          *.cm)          *.cm | *.cmi)
282              if [ $lib != $2 ] ; then              if [ $lib != $2 ] ; then
283                  echo "! Warning:" $lib specified relative to $2                  echo "! Warning:" $lib specified relative to $2
284              fi              fi
# Line 213  Line 344 
344          echo Target $TARGET already exists.          echo Target $TARGET already exists.
345      else      else
346          echo Building $TARGET.          echo Building $TARGET.
347          unpack $2 $SRCDIR $1 $ROOT/$VERSION-$1          unpack $2 $SRCDIR $1 $1
348          cd $SRCDIR/$1          cd $SRCDIR/$1
349          ./build          ./build
350          if [ -r $TARGETLOC ] ; then          if [ -r $TARGETLOC ] ; then
# Line 236  Line 367 
367      makedir $dir      makedir $dir
368  done  done
369    
   
370  #  #
371  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
372  #  #
373  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
374    echo Script $BINDIR/.arch-n-opsys already exists.    echo Script $BINDIR/.arch-n-opsys already exists.
375  else  else
376    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      cat $CONFIGDIR/_arch-n-opsys \
377        | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
378    chmod 555 $BINDIR/.arch-n-opsys    chmod 555 $BINDIR/.arch-n-opsys
379    if [ ! -x $BINDIR/.arch-n-opsys ]; then    if [ ! -x $BINDIR/.arch-n-opsys ]; then
380      echo "!!! Installation of $BINDIR/.arch-n-opsys failed for some reason."          echo "!!! Installation of $BINDIR/.arch-n-opsys failed."
381      exit 1      exit 1
382    fi    fi
383  fi  fi
384    
385  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
386  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
387    echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."    echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."
# Line 260  Line 392 
392  fi  fi
393  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
394    
395  if [ -x $BINDIR/.run-sml ]; then  #
396    echo Script $BINDIR/.run-sml already exists.  # Function to install a "driver" script...
397  else  #   This takes care of patching the source of the script with the SHELL,
398    cat $CONFIGDIR/_run-sml | \  #   BINDIR, and VERSION variables to use.
399      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  #
400      > $BINDIR/.run-sml  installdriver() {
401    chmod 555 $BINDIR/.run-sml      dsrc=$1
402    if [ ! -x $BINDIR/.run-sml ]; then      ddst=$2
403      echo "!!! Installation of $BINDIR/.run-sml failed for some reason."  # We install the driver unconditionally. (It would be better to test
404    # for an outdated driver script, but not all "test" commands understand
405    # the -nt comparison operator....)
406    #   if [ -x $BINDIR/$ddst ]; then
407    #       echo Script $BINDIR/$ddst already exists.
408    #   else
409            rm -f $BINDIR/$ddst
410            cat $CONFIGDIR/$dsrc | \
411            sed -e "s,@SHELL@,$SHELL,g" \
412                -e "s,@BINDIR@,$BINDIR," \
413                -e "s,@VERSION@,$VERSION," \
414                > $BINDIR/$ddst
415            chmod 555 $BINDIR/$ddst
416            if [ ! -x $BINDIR/$ddst ]; then
417                echo "!!! Installation of $BINDIR/${ddst} failed."
418      exit 1      exit 1
419    fi    fi
420  fi  #   fi
421    }
422    
423    installdriver _run-sml .run-sml
424    installdriver _link-sml .link-sml
425    installdriver _ml-build ml-build
426    
427  #  #
428  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
429  #  #
430  case $ARCH in  case $ARCH in
431    mips*) ALLOC=1M ;;      mips*)
432            ALLOC=1M
433            ;;
434    x86)    x86)
435      ALLOC=256k      ALLOC=256k
436    ;;    ;;
# Line 288  Line 441 
441      ALLOC=512k      ALLOC=512k
442    ;;    ;;
443  esac  esac
444    
445  case $OPSYS in  case $OPSYS in
446    solaris)    solaris)
447      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 305  Line 459 
459  #  #
460  # the name of the bin files directory  # the name of the bin files directory
461  #  #
462  BOOT_FILES=comp.boot.$ARCH-unix  BOOT_FILES=sml.boot.$ARCH-unix
463    
464  #  #
465  # build the run-time system  # build the run-time system
466  #  #
467  unpack "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime  unpack "run-time" $SRCDIR runtime runtime
468  if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
469        echo Run-time system already exists.
470    else
471    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
472    echo Compiling the run-time system.    echo Compiling the run-time system.
473    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
# Line 331  Line 487 
487  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
488    echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.    echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
489  else  else
490    unpack bin $ROOT $BOOT_FILES $ROOT/$VERSION-$BOOT_FILES      unpack bin $ROOT $BOOT_FILES $BOOT_FILES
491    cd $ROOT      cd $ROOT/$BOOT_FILES
492    if $RUNDIR/run.$ARCH-$OPSYS @SMLheap=sml \      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
         @SMLboot=$ROOT/$BOOT_FILES @SMLrtpid=`cat $BOOT_FILES/RTPID` \  
         @SMLalloc=$ALLOC  
493    then    then
494            cd $ROOT
495      if [ -r sml.$HEAP_SUFFIX ]; then      if [ -r sml.$HEAP_SUFFIX ]; then
496          mv sml.$HEAP_SUFFIX $HEAPDIR          mv sml.$HEAP_SUFFIX $HEAPDIR
497          cd $BINDIR          cd $BINDIR
498          ln -s .run-sml sml          ln -s .run-sml sml
   
499          #          #
500          # Now move all stable libraries to #LIBDIR and generate          # Now move all stable libraries to #LIBDIR and generate
501          # the pathconfig file.          # the pathconfig file.
502          #          #
   
503          cd $ROOT/$BOOT_FILES          cd $ROOT/$BOOT_FILES
504          for lib in *.cm ; do              for anchor in * ; do
505              echo $lib $LIBDIR/$lib >>$CM_PATHCONFIG_DEFAULT                  if [ -d $anchor ] ; then
506              movelibs $ROOT/$BOOT_FILES/$lib $lib                      echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT
507                        move $anchor $LIBDIR/$anchor
508                    fi
509          done          done
510          cd $ROOT          cd $ROOT
511          # rm -rf $BOOT_FILES              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
512                rm -rf $BOOT_FILES
513    
514      else      else
515          echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."          echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."
# Line 380  Line 536 
536  for i in $TARGETS ; do  for i in $TARGETS ; do
537      case $i in      case $i in
538        src-smlnj)        src-smlnj)
539          for src in compiler comp-lib cm MLRISC smlnj-lib ml-yacc system          for src in compiler cm MLRISC smlnj-lib ml-yacc system
540          do          do
541              unpack $src $ROOT/src $src $ROOT/$VERSION-$src              unpack $src $ROOT/src $src $src
542          done          done
543          ;;          ;;
544        ml-yacc)        ml-yacc)
545          standalone ml-yacc ML-Yacc src          standalone ml-yacc ML-Yacc src
546            echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
547          ;;          ;;
548        ml-lex)        ml-lex)
549          standalone ml-lex ML-Lex          standalone ml-lex ML-Lex
550            echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
551          ;;          ;;
552        ml-burg)        ml-burg)
553          standalone ml-burg ML-Burg          standalone ml-burg ML-Burg
554            echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
555          ;;          ;;
556        smlnj-lib)        smlnj-lib)
557          unpack "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
558    
559          # Don't make the Util library -- it came pre-made and has been          # Don't make the Util library -- it came pre-made and has been
560          # installed when making the base system.  In other words, don't do...          # installed when making the base system.  In other words, don't do...
561              #reglib smlnj-lib.cm smlnj-lib/Util              #reglib smlnj-lib.cm smlnj-lib/Util
562            # ... and don't make the HTML library ...
563                #reglib html-lib.cm smlnj-lib/HTML
564            # ... and don't make the PP library ...
565                #reglib pp-lib.cm smlnj-lib/PP
566          # make the Unix library          # make the Unix library
567              reglib unix-lib.cm smlnj-lib/Unix              reglib unix-lib.cm smlnj-lib/Unix
568          # make the INet library          # make the INet library
569              reglib inet-lib.cm smlnj-lib/INet              reglib inet-lib.cm smlnj-lib/INet
         # make the HTML library  
             reglib html-lib.cm smlnj-lib/HTML  
         # make the PP library  
             reglib pp-lib.cm smlnj-lib/PP  
570          # make the RegExp library          # make the RegExp library
571              reglib regexp-lib.cm smlnj-lib/RegExp              reglib regexp-lib.cm smlnj-lib/RegExp
572          # make the Reactive library          # make the Reactive library
573              reglib reactive-lib.cm smlnj-lib/Reactive              reglib reactive-lib.cm smlnj-lib/Reactive
574          ;;          ;;
575        cml)        cml)
576          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
577          reglib core-cml.cm cml/src/core-cml          reglib core-cml.cm cml/src/core-cml
578          reglib cml.cm cml/src          reglib cml.cm cml/src
579          reglib cml-basis.cm cml          reglib cml-basis.cm cml
580          ;;          ;;
581        cml-lib)        cml-lib)
582          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
583          reglib cml-lib.cm cml/cml-lib          reglib cml-lib.cm cml/cml-lib
584          ;;          ;;
585        eXene)        eXene)
586          unpack EXene $SRCDIR eXene $ROOT/$VERSION-eXene          unpack EXene $SRCDIR eXene eXene
587          reglib eXene.cm eXene          reglib eXene.cm eXene
588          ;;          ;;
589        doc)        doc)
590          unpack Doc $ROOT doc $ROOT/$VERSION-doc          unpack Doc $ROOT doc doc
591          cd $ROOT/doc          cd $ROOT/doc
592          build $ROOT          build $ROOT
593          ;;          ;;
# Line 452  Line 611 
611      echo "!!! Something went wrong when compiling the libraries."      echo "!!! Something went wrong when compiling the libraries."
612      exit 1      exit 1
613  fi  fi
 rm -f $LIBLIST $LOCALPATHCONFIG  
614    
615  #  #
616  # Finally, move the libraries to their final locations...  # Finally, move the libraries to their final locations...
# Line 461  Line 619 
619  if [ -r $LIBMOVESCRIPT ] ; then  if [ -r $LIBMOVESCRIPT ] ; then
620      echo Moving libraries to $LIBDIR.      echo Moving libraries to $LIBDIR.
621      . $LIBMOVESCRIPT      . $LIBMOVESCRIPT
     rm -f $LIBMOVESCRIPT  
622  fi  fi
623    
624    exit 0

Legend:
Removed from v.489  
changed lines
  Added in v.573

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0